Name:           g2clib
Version:        1.2.3
Release:        1
Summary:        GRIB2 encoder/decoder and search/indexing routines in C

Group:          System Environment/Libraries
License:        Public Domain
URL:            http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
Source0:        http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/g2clib-%{version}.tar.bz2
Source1:        %{name}-msg.txt
# patch to fix up printf arguments on 64-bit machines
Patch0:         %{name}-1.2.1-64bit.patch
# patch to remove multiple definitions of templates
Patch1:         %{name}-templates.patch
# patch for AIX
Patch2:         %{name}-%{version}-aix.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  patch
BuildRequires:  jasper-devel >= 1.900.1-2
BuildRequires:  libpng-devel >= 1.2.46
BuildRequires:  zlib-devel
Requires:       jasper >= 1.900.1-2
Requires:       libpng >= 1.2.46
Requires:       zlib

%description
This library contains "C" decoder/encoder
routines for GRIB edition 2.  The user API for the GRIB2 routines
is described in file "grib2c.doc".

The library is available as 32-bit and 64-bit.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       jasper-devel >= 1.900.1-2
Requires:       libpng-devel >= 1.2.46
Requires:       zlib-devel

%description    devel
This library contains "C" decoder/encoder
routines for GRIB edition 2.  The user API for the GRIB2 routines
is described in file "grib2c.doc".

The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0 -p1 -b .64bit
%patch1 -p1 -b .templates
%patch2
chmod a-x *.h *.c README CHANGES grib2c.doc makefile
cp -p %{SOURCE1} .


%build
export OBJECT_MODE=64
make
CreateExportList -X64 libgrib2c.exp libgrib2c.a
${CC} -qmkshrobj libgrib2c.a -o shr64.o -bE:libgrib2c.exp -bernotok -lm -L/opt/freeware/lib -lpng -lz -ljasper
rm -f libgrib2c.exp libgrib2c.a

export OBJECT_MODE=32
make
CreateExportList -X32 libgrib2c.exp libgrib2c.a
${CC} -qmkshrobj libgrib2c.a -o shr32.o -bE:libgrib2c.exp -bernotok -lm -L/opt/freeware/lib -lpng -lz -ljasper
rm -f %{name}.exp libgrib2c.a

/usr/bin/ar -X64 -rv libgrib2c.a shr64.o
/usr/bin/ar -X32 -q  libgrib2c.a shr32.o


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
cp libgrib2c.a ${RPM_BUILD_ROOT}%{_libdir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_libdir}/*

mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
cp grib2.h drstemplates.h gridtemplates.h pdstemplates.h ${RPM_BUILD_ROOT}%{_includedir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_includedir}/*

(
  cd ${RPM_BUILD_ROOT}
  for dir in include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc README CHANGES grib2c.doc g2clib-msg.txt
%{_libdir}/*.a
/usr/lib/*.a


%files devel
%defattr(-,root,system,-)
%doc README CHANGES grib2c.doc g2clib-msg.txt
%{_includedir}/*
/usr/include/*


%changelog
* Thu Jul 12 2012 Michael Perzl <michael@perzl.org> - 1.2.3-1
- first version for AIX V5.1 and higher
